<?php
namespace PME\Controllers\Cardapio;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class AcompanhamentoCusto {
	protected $connection;
	protected $utilities;

    public function __construct($connection, $utilities) {
        $this->connection = $connection;
        $this->utilities = $utilities;
	}
	
	public function callProcedureConsPlan(DTO\Request\Row $request, DTO\Response $response) {
		$row = $request->getRow();
		try {
		    $cdfilcentpme = $row['cdfilcentpme'];
		    $cdtipocard = $row['typeMenu']['CDTIPOCARD'];
		    $filial = ($row['aggregated'] !== NULL) ? $row['aggregated']['CDFILIAL'] : $row['aggregated'];
		    $servico = $row['service']['CDSERVFILI'];
		    $initialDate = $row['initialDate'];
		    $finalDate = $row['finalDate'];
		    
			$consplan = $this->utilities->consumoPlanPMe($cdfilcentpme, $cdtipocard, $filial, $servico, $initialDate, $finalDate, 'T', 'P');
			$response->addDataSet(new DataSet("consplan", array($consplan)));
		} catch (\Exception $e) {
	    	$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function deleteConsPlan(DTO\Request\Row $request, DTO\Response $response) {
		$row = $request->getRow();
		try {
			$query = "DELETE FROM CONSPLAN WHERE NRCONSPLAN = :NRCONSPLAN AND CDFILICPLA = :CDFILICPLA AND CDSERVCPLA = :CDSERVCPLA";
			$params = array(
				"NRCONSPLAN" => $row['CONSPLAN'],
				"CDFILICPLA" => $row['cdfilcentpme'],
				"CDSERVCPLA" => $row['service']['CDSERVFILI']
			);
			$stmt = $this->connection->prepare($query)->execute($params);
			$response->addDataSet(new DataSet("hasExclude", array(true)));
		} catch (\Exception $e) {
	    	$response->setError(new Error($e->getMessage(), 500));
		}
	}
}